#INCLUDE "PROTHEUS.CH"
#include "RWMAKE.ch"
#include "Colors.ch"                                                             
#include "Font.ch"                                       
#Include "HBUTTON.CH"
#include "Topconn.ch"

User Function BRP294()
Local   aTipo      :={'N','B','D'}
Local _aAreaBR := GetArea()   
Private CPERG      :="BRP294"
Private _cMarca    := GetMark()
Private aFields    := {} 
Private aFields2   := {}
Private aTit       := {}
Private aTit2      := {}
	
ValidPerg()
Pergunte(cPERG,.T.)        


aCampos := {}
aCampos2:= {}  
cVlrRec:=cVlrPag:=0

AADD(aCampos,{'T9_OK'			,'#','@!','2','0'})
AADD(aCampos,{'T9_PREFIXO'		,'Prefixo','@!','2','0'})
AADD(aCampos,{'T9_NUM'			,'Titulo', '@!','9','0'})
AADD(aCampos,{'T9_NATUREZ'		,'Natureza','@!','10','0'})
AADD(aCampos,{'T9_PARCELA'		,'Parcela','@!','3','0'})
AADD(aCampos,{'T9_VALOR'		,'Valor','@EZ 999,999,999.999999','15','6'})
AADD(aCampos,{'T9_SALDO'		,'Saldo','@EZ 999,999,999.999999','15','6'}) 
AADD(aCampos,{'T9_TIPO'			,'Tipo',   '@!','3','0'})
AADD(aCampos,{'T9_CLIENTE' 		,'Cliente','@!','6','0'})
AADD(aCampos,{'T9_LOJA'		    ,'Loja',   '@!','2','0'}) 
AADD(aCampos,{'T9_NOMCLI'		,'Nome',   '@!','25','0'})  
AADD(aCampos,{'T9_EMISSAO'		,'Emissao','','10','0'})
AADD(aCampos,{'T9_VENCREA'		,'Venc.Real','','10','0'})  

AADD(aCampos2,{'T8_OK'			,'#','@!','2','0'})
AADD(aCampos2,{'T8_PREFIXO'		,'Prefixo','@!','2','0'})
AADD(aCampos2,{'T8_NUM'			,'Titulo', '@!','9','0'})
AADD(aCampos2,{'T8_NATUREZ'		,'Natureza','@!','10','0'})
AADD(aCampos2,{'T8_PARCELA'		,'Parcela','@!','3','0'})
AADD(aCampos2,{'T8_VALOR'		,'Valor','@EZ 999,999,999.999999','15','6'})
AADD(aCampos2,{'T8_SALDO'		,'Saldo','@EZ 999,999,999.999999','15','6'}) 
AADD(aCampos2,{'T8_TIPO'			,'Tipo',   '@!','3','0'})
AADD(aCampos2,{'T8_FORNECE' 		,'Fornecedor','@!','6','0'})
AADD(aCampos2,{'T8_LOJA'		    ,'Loja',   '@!','2','0'}) 
AADD(aCampos2,{'T8_NOMFOR'		,'Nome',   '@!','25','0'})  
AADD(aCampos2,{'T8_EMISSAO'		,'Emissao','','10','0'})
AADD(aCampos2,{'T8_VENCREA'		,'Venc.Real','','10','0'})  
	
Cria_TC9()
	
lOk:=.F. 
nNumSeq  := 1
nSaldo   := 0  
nVlrMail := 0
nValZZC  := 0 
nDocCt2  := space(6)
nLin     := 1
cConta   := nSeqCt2 := space(20)

Monta_TC9()
Monta_TC8() 

	
If !Empty(TC9->(RecCount()))
		
		DbSelectArea('TC9')
		@ 100,005 TO 500,750 DIALOG oDlgTitulos TITLE "Central Endosso"
		
		
		@ 006,005 TO 100,325 BROWSE "TC9" MARK "T9_OK" FIELDS aCampos Object _oBrwPed
				
		@ 016,330 BUTTON "Marcar"         SIZE 40,15 ACTION MsAguarde({|| MarcarTudo()},'Marcando Registros...')
		@ 036,330 BUTTON "Desmarcar"      SIZE 40,15 ACTION MsAguarde({|| DesMarcaTudo()},'Desmarcando Registros...')
		@ 056,330 BUTTON "Gerar Endosso"  SIZE 40,15 ACTION MsAguarde({|| Endossa() , Close(oDlgTitulos)},'Gerando Endossos...')
		@ 076,330 BUTTON "Gerar Cartas"   SIZE 40,15 ACTION MsAguarde({|| U_Brp295()},'Gerando Cartas...')
		@ 096,330 BUTTON "Imp. Duplicata" SIZE 40,15 ACTION MsAguarde({|| U_DuplBres(),},'Imprimindo Duplicata...')
		@ 116,330 BUTTON "Cad.Endosso"    SIZE 40,15 ACTION MsAguarde({|| U_Brp296()},'Cadastro de Endosso....')
	   	@ 136,330 BUTTON "Calcular"       SIZE 40,15 ACTION MsAguarde({|| calcular()},'Calculando Titulos Selecionados....')
	   	@ 156,330 BUTTON "_Sair"          SIZE 40,15 ACTION Close(oDlgTitulos)
				
		DbSelectArea('TC8')
		
		@ 100,005 TO 190,325 BROWSE "TC8" MARK "T8_OK" FIELDS aCampos2 Object _oBrwPed2
				
		DbSelectArea('TC9')
		
		_oBrwPed:bMark := {|| Marcar()}
		
		_oBrwPed2:bMark := {|| MarcarTC8()} 		
		
		ACTIVATE DIALOG oDlgTitulos CENTERED
return
Endif
	
static function calcular()	
Local _aAreaBR := GetArea()

	MsgAlert("Selecao a Receber : " +alltrim(str(cVlrRec))+ " Selecao a Pagar: " +alltrim(str(cVlrPag)))//,"Atencao","ALERT") 

return //return calcular()


static function endossa()	

//IF MsgYesNo("O Total de Selecao do Contas a Receber foi de : " + alltrim(str(cVlrRec)) + " e o Total de Selecao do Contas a Pagar foi de : " + alltrim(str(cVlrPag)) + ".  Tem Certeza que Deseja Continuar?" )  
IF MsgYesNo("Voce selecionou a opo Gerar Endosso. Esta rotina ira baixar os titulos, gerar compensaes, contabilizaes e historico.  Tem Certeza que Deseja Continuar?" )  
	
	dbSelectArea("TC9")
	dbGoTop()
	ProcRegua(Reccount())
	
	lMarcou := .f.
	
	While !Eof() 
		IncProc()
		If TC9->T9_OK  <> _cMarca
			dbSelectArea("TC9")
			TC9->(dbSkip(1));Loop
		Else
			lMarcou := .t.
			Exit
		Endif
		
		TC9->(dbSkip(1))
	Enddo
	
	If lMarcou
		
		dbSelectArea("TC9")
		dbGoTop()
		ProcRegua(Reccount())
		
		While !Eof()
			IncProc()
			If TC9->T9_OK  <> _cMarca                                      
				dbSelectArea("TC9")
				TC9->(dbSkip(1));Loop
			Endif
			
			cQuery:="BEGIN TRAN "
			cQuery+="UPDATE "+RetSqlName("SE1")+" SET E1_PORTADO='END',E1_SITUACA='1' WHERE D_E_L_E_T_<>'*' AND E1_PREFIXO = '"+TC9->T9_PREFIXO+"' AND "
			cQuery+="E1_NUM = '"+TC9->T9_NUM+"' AND E1_CLIENTE =  '"+TC9->T9_CLIENTE+"' AND E1_LOJA = '"+TC9->T9_LOJA+"' AND "
			cQuery+="E1_PARCELA = '"+TC9->T9_PARCELA+"' AND E1_TIPO = '"+TC9->T9_TIPO+"' AND E1_PORTADO='' "
			cQuery+="COMMIT"
			TCSQLExec(cQuery)
			
			AADD(aTit,{TC9->T9_PREFIXO,TC9->T9_NUM,TC9->T9_PARCELA,TC9->T9_TIPO,TC9->T9_CLIENTE,TC9->T9_LOJA,TC9->T9_NOMCLI,TC9->T9_EMISSAO,TC9->T9_VENCREA,TC9->T9_VALOR,TC9->T9_SALDO,TC9->T9_NATUREZ})
			TC9->(dbSkip())
		Enddo
		TC9->(dbCloseArea())
				
	    cNUM := GetSX8Num("ZZC","ZZC_DOC")    
        CONFIRMSX8()
	ENDIF
    
    dbSelectArea("TC8")
	dbGoTop()
	ProcRegua(Reccount())
	
	lMarcou := .f.
	
	While !Eof() 
		IncProc()
		If TC8->T8_OK  <> _cMarca
			dbSelectArea("TC8")
			TC8->(dbSkip(1));Loop
		Else
			lMarcou := .t.
			Exit
		Endif
		
		TC8->(dbSkip(1))
	Enddo
	
	If lMarcou
		
		dbSelectArea("TC8")
		dbGoTop()
		ProcRegua(Reccount())
		
		While !Eof() 
			IncProc()
			If TC8->T8_OK  <> _cMarca
				dbSelectArea("TC8")
				TC8->(dbSkip(1));Loop
			Endif
			
			cQuery:="BEGIN TRAN "
			cQuery+="UPDATE "+RetSqlName("SE2")+" SET E2_PORTADO='END' WHERE D_E_L_E_T_<>'*' AND E2_PREFIXO = '"+TC8->T8_PREFIXO+"' AND "
			cQuery+="E2_NUM = '"+TC8->T8_NUM+"' AND E2_FORNECE =  '"+TC8->T8_FORNECE+"' AND E2_LOJA = '"+TC8->T8_LOJA+"' AND "
			cQuery+="E2_PARCELA = '"+TC8->T8_PARCELA+"' AND E2_TIPO = '"+TC8->T8_TIPO+"' AND E2_PORTADO='' "
			cQuery+="COMMIT"
			TCSQLExec(cQuery)
			
			AADD(aTit2,{TC8->T8_PREFIXO,TC8->T8_NUM,TC8->T8_PARCELA,TC8->T8_TIPO,TC8->T8_FORNECE,TC8->T8_LOJA,TC8->T8_NOMFOR,TC8->T8_EMISSAO,TC8->T8_VENCREA,TC8->T8_VALOR,TC8->T8_SALDO,TC8->T8_NATUREZ})
			TC8->(dbSkip())
		Enddo
		TC8->(dbCloseArea())
	ENDIF 
    
    // geracao das compensaes
    
    //AADD(aTit,{TC9->T9_PREFIXO,TC9->T9_NUM,TC9->T9_PARCELA,TC9->T9_TIPO,TC9->T9_CLIENTE,TC9->T9_LOJA,TC9->T9_NOMCLI,TC9->T9_EMISSAO,TC9->T9_VENCREA,TC9->T9_VALOR,TC9->T9_SALDO,TC9->E1_NATUREZ})
   // AADD(aTit,{TC9->T9_PREFIXO,TC9->T9_NUM,TC9->T9_PARCELA,TC9->T9_TIPO,TC9->T9_CLIENTE,TC9->T9_LOJA,TC9->T9_NOMCLI,TC9->T9_EMISSAO,TC9->T9_VENCREA,TC9->T9_VALOR,TC9->T9_SALDO,TC9->E1_NATUREZ})
    
    for i:=1 to Len(aTit) //array do contas a receber
       
       nSaldo  := aTit[i,11] //comparacao receber
       nSaldo3 := aTit[i,11] //comparacao pagar
       nPrfRec := aTit[i,1]
       
       
       for n:=1 to Len(aTit2) //array do contas a pagar
      
           nPrfPag := aTit2[n,1]
           
           cQuery:="SELECT E2_SALDO AS SALDO FROM "+RetSqlName("SE2")+" WHERE D_E_L_E_T_<>'*' AND E2_PREFIXO = '"+aTit2[n,1]+"' AND "
           cQuery+="E2_NUM = '"+aTit2[n,2]+"' AND E2_PARCELA = '"+aTit2[n,3]+"' AND E2_TIPO = '"+aTit2[n,4]+"' AND E2_FORNECE = '"+aTit2[n,5]+"' AND "  
           cQuery+="E2_LOJA = '"+aTit2[n,6]+"' AND E2_EMISSAO = '"+DTOS(aTit2[n,8])+"' " 
           ChangeQuery(cQuery)
           DbUseArea(.T., "TOPCONN", TCGenQry(,,cQuery), 'SLDE2', .F., .T.)
           
           IF SLDE2->SALDO > 0
               nSaldo2 := ROUND(SLDE2->SALDO,2) //comparacao receber
               nSaldo4 := ROUND(SLDE2->SALDO,2) //comparacao pagar  
           ELSE
               nSaldo2 := nSaldo4 := 0
           ENDIF
           SLDE2->(DBCLOSEAREA())
           
           if nSaldo2 > 0 .and. nSaldo4 > 0
           
              if nSaldo2 > 0 .and. nSaldo > 0
                 
                 //GERACAO SE5 CONTAS A RECEBER
                 
                 IF RECLOCK("SE5",.T.)
	      		    REPLACE SE5->E5_PREFIXO  WITH  aTit[i,1]
   	      		    REPLACE SE5->E5_DATA     WITH  DDATABASE
   	      		    REPLACE SE5->E5_TIPO     WITH  aTit[i,4]
		   	        REPLACE SE5->E5_MOEDA    WITH  "01"
		   	        REPLACE SE5->E5_DOCZZC   WITH  cNUM
		   	        REPLACE SE5->E5_SEQZZC   WITH  alltrim(strzero(nNumSeq,3))
		   	     
		   	        if nSaldo > nSaldo2
		   	     
		   	             REPLACE SE5->E5_VALOR    WITH  nSaldo2
		   	        	 REPLACE SE5->E5_VLMOED2  WITH  nSaldo2 
   	      		         
   	      		         if (nPrfRec == "07" .and. nPrfPag == "01") .or. (nPrfRec == "01" .and. nPrfPag == "07")
   	      		            nVlrMail:=nSaldo2
   	      		            U_EnviaMail() // enviar e-mail  	      		              
   	      		         endif
   	      		            	      		         
   	      		         nValZZC := nSaldo2
   	      		    	 nSaldo := nSaldo - nSaldo2 
   	      		         
   	      		    	 //baixar o titulo na se1
   	      		    	 //cQuery:="UPDATE "+RetSqlName("SE1")+" SET E1_BAIXA='"+DTOS(DDATABASE)+"',E1_VALLIQ='"+ALLTRIM(STR(nSaldo2))+"', "
   	      		    	 cQuery:="BEGIN TRAN "
   	      		    	 cQuery+="UPDATE "+RetSqlName("SE1")+" SET E1_BAIXA='"+DTOS(DDATABASE)+"', "
   	      		    	 cQuery+="E1_SALDO = (E1_SALDO - "+ALLTRIM(STR(nSaldo2))+") "
   	      		    	 cQuery+="WHERE D_E_L_E_T_<>'*' AND E1_PREFIXO = '"+aTit[i,1]+"' AND "
			        	 cQuery+="E1_NUM = '"+aTit[i,2]+"' AND E1_CLIENTE =  '"+aTit[i,5]+"' AND E1_LOJA = '"+aTit[i,6]+"' AND "
			        	 cQuery+="E1_PARCELA = '"+aTit[i,3]+"' AND E1_TIPO = '"+aTit[i,4]+"' AND E1_PORTADO IN ('END','ENE') "
			        	 cQuery+="COMMIT"
			        	 TCSQLExec(cQuery)
			        	 
			        	 //GERACAO DO MOVIMENTO CREDITO NA CT2 (CONTABILIZAO)
			        	 
			        	 IF EMPTY(nDocCt2) //SE AINDA NAO PEGOU O NUMERO DO DOC DA CT2
			        	    cQuery:="SELECT TOP 1 (CT2_DOC) + 1 AS PROX FROM "+RetSqlName("CT2")+"  WHERE CT2_LOTE='008850' "
			        	    cQuery+="AND CT2_DATA='"+DTOS(DDATABASE)+"' "
			        	    cQuery+="GROUP BY CT2_DOC ORDER BY CT2_DOC DESC "
			        	    ChangeQuery(cQuery)
                            DbUseArea(.T., "TOPCONN", TCGenQry(,,cQuery), 'DOCCT2', .F., .T.)
                         
                            nDocCt2 := ALLTRIM(STRZERO(DOCCT2->PROX,6)) //numero documento
                            DOCCT2->(DBCLOSEAREA()) 
                            
                            if EMPTY (nDocCt2) .or. nDocCt2 == "000000"
                               nDocCt2 := "000001"
                            endif   
                            
                            cQuery:="SELECT TOP 1 (CT2_SEQUEN) + 1 AS PROX FROM "+RetSqlName("CT2")+"  WHERE CT2_LOTE='008850' "
			        	    cQuery+="GROUP BY CT2_SEQUEN ORDER BY CT2_SEQUEN DESC "
			        	    ChangeQuery(cQuery)
                            DbUseArea(.T., "TOPCONN", TCGenQry(,,cQuery), 'SEQCT2', .F., .T.)
                         
                            nSeqCt2 := ALLTRIM(STRZERO(SEQCT2->PROX,10)) //numero documento
                            SEQCT2->(DBCLOSEAREA())
                            
                         ENDIF
			        	 
			        	 cConta := ALLTRIM(POSICIONE("SA1",1,xFILIAL("SA1")+aTit[i,5]+aTit[i,6],"A1_CONTA"))   //conta contabil cadastro de cliente
			        	 
			        	 IF RECLOCK("CT2",.T.) 
			        	    REPLACE CT2->CT2_DATA    WITH DDATABASE
   	      		    	    REPLACE CT2->CT2_LOTE    WITH "008850" 
   	      		    	    REPLACE CT2->CT2_DOCZZC  WITH cNUM
   	      		    	    REPLACE CT2->CT2_SEQZZC  WITH alltrim(strzero(nNumSeq,3))
   	      		    	    REPLACE CT2->CT2_SBLOTE  WITH "001"
   	      		    	    REPLACE CT2->CT2_DOC     WITH nDocCt2
   	      		    	    REPLACE CT2->CT2_LINHA   WITH ALLTRIM(STRZERO(nLin,3)) 
   	      		    	    REPLACE CT2->CT2_MOEDLC  WITH "01"
   	      		    	    REPLACE CT2->CT2_DC      WITH "2" 
   	      		    	    REPLACE CT2->CT2_CREDIT  WITH cConta
   	      		    	    REPLACE CT2->CT2_VALOR   WITH nSaldo2
   	      		    	    REPLACE CT2->CT2_HIST    WITH "CEC " +aTit2[n,1]+ " " +alltrim(aTit2[n,2])+ " " +alltrim(aTit2[n,7])
   	      		    	    REPLACE CT2->CT2_ITEMC   WITH aTit[i,1]
   	      		    	    REPLACE CT2->CT2_EMPORI  WITH "01"
		  		    	    REPLACE CT2->CT2_FILORI  WITH aTit[i,1]  
		  		    	    REPLACE CT2->CT2_TPSALD  WITH "9"
   	      		    	    REPLACE CT2->CT2_SEQUEN  WITH nSeqCt2
   	      		    	    REPLACE CT2->CT2_MANUAL  WITH "2"
   	      		    	    REPLACE CT2->CT2_ORIGEM  WITH "BRP294"
   	      		    	    REPLACE CT2->CT2_ROTINA  WITH "BRP294"
   	      		    	    REPLACE CT2->CT2_AGLUT   WITH "1"
   	      		    	    REPLACE CT2->CT2_LP      WITH "000"
   	      		    	    REPLACE CT2->CT2_SEQHIS  WITH "001"
   	      		    	    REPLACE CT2->CT2_SEQLAN  WITH ALLTRIM(STRZERO(nLin,3))
   	      		    	    nLin := nLin + 1 
   	      		    	    REPLACE CT2->CT2_CRCONV  WITH "1"
   	      		    	    REPLACE CT2->CT2_DTCV3   WITH DDATABASE
   	      		    	    
			        	 ENDIF   
			        	    CT2->(MSUNLOCK())  //FIM GERACAO DA CT2
   	      		 
   	      		 	elseif nSaldo <= nSaldo2          
   	      		         REPLACE SE5->E5_VALOR    WITH  nSaldo
   	      		    	 REPLACE SE5->E5_VLMOED2  WITH  nSaldo 
   	      		    	 nValZZC := nSaldo
   	      		    	 
   	      		    	 if (nPrfRec == "07" .and. nPrfPag == "01") .or. (nPrfRec == "01" .and. nPrfPag == "07")
   	      		    	    nVlrMail:=nSaldo
   	      		            U_EnviaMail() // enviar e-mail  	      		              
   	      		         endif
   	      		            	      		    	 
   	      		    	 //cQuery:="UPDATE "+RetSqlName("SE1")+" SET E1_BAIXA='"+DTOS(DDATABASE)+"',E1_STATUS='B',E1_VALLIQ=E1_VALOR,E1_SALDO='0' "
   	      		    	 cQuery:="BEGIN TRAN "
   	      		    	 cQuery+="UPDATE "+RetSqlName("SE1")+" SET E1_BAIXA='"+DTOS(DDATABASE)+"',E1_STATUS='B',E1_SALDO='0' "
   	      		         cQuery+="WHERE D_E_L_E_T_<>'*' AND E1_PREFIXO = '"+aTit[i,1]+"' AND "
			        	 cQuery+="E1_NUM = '"+aTit[i,2]+"' AND E1_CLIENTE =  '"+aTit[i,5]+"' AND E1_LOJA = '"+aTit[i,6]+"' AND "
			        	 cQuery+="E1_PARCELA = '"+aTit[i,3]+"' AND E1_TIPO = '"+aTit[i,4]+"' AND E1_PORTADO IN ('END','ENE') "
			        	 cQuery+="COMMIT"
			        	 TCSQLExec(cQuery) 
			        	 
			        	 //GERACAO DO MOVIMENTO CREDITO NA CT2 (CONTABILIZAO)
			        	 
			        	 IF EMPTY(nDocCt2) //SE AINDA NAO PEGOU O NUMERO DO DOC DA CT2
			        	    cQuery:="SELECT TOP 1 (CT2_DOC) + 1 AS PROX FROM "+RetSqlName("CT2")+"  WHERE CT2_LOTE='008850' "
			        	    cQuery+="AND CT2_DATA='"+DTOS(DDATABASE)+"' "
			        	    cQuery+="GROUP BY CT2_DOC ORDER BY CT2_DOC DESC "
			        	    ChangeQuery(cQuery)
                            DbUseArea(.T., "TOPCONN", TCGenQry(,,cQuery), 'DOCCT2', .F., .T.)
                         
                            nDocCt2 := ALLTRIM(STRZERO(DOCCT2->PROX,6)) //numero documento
                            DOCCT2->(DBCLOSEAREA())
                            
                            if EMPTY (nDocCt2) .or. nDocCt2 == "000000"
                               nDocCt2 := "000001"
                            endif   
                            
                            cQuery:="SELECT TOP 1 (CT2_SEQUEN) + 1 AS PROX FROM "+RetSqlName("CT2")+"  WHERE CT2_LOTE='008850' "
			        	    cQuery+="GROUP BY CT2_SEQUEN ORDER BY CT2_SEQUEN DESC "
			        	    ChangeQuery(cQuery)
                            DbUseArea(.T., "TOPCONN", TCGenQry(,,cQuery), 'SEQCT2', .F., .T.)
                         
                            nSeqCt2 := ALLTRIM(STRZERO(SEQCT2->PROX,10)) //numero documento
                            SEQCT2->(DBCLOSEAREA())
                            
                         ENDIF
			        	 
			        	 cConta := ALLTRIM(POSICIONE("SA1",1,xFILIAL("SA1")+aTit[i,5]+aTit[i,6],"A1_CONTA"))   //conta contabil cadastro de cliente
			        	 
			        	 IF RECLOCK("CT2",.T.) 
			        	    REPLACE CT2->CT2_DATA    WITH DDATABASE
   	      		    	    REPLACE CT2->CT2_LOTE    WITH "008850" 
   	      		    	    REPLACE CT2->CT2_DOCZZC  WITH cNUM
   	      		    	    REPLACE CT2->CT2_SEQZZC  WITH alltrim(strzero(nNumSeq,3))
   	      		    	    REPLACE CT2->CT2_SBLOTE  WITH "001"
   	      		    	    REPLACE CT2->CT2_DOC     WITH nDocCt2
   	      		    	    REPLACE CT2->CT2_LINHA   WITH ALLTRIM(STRZERO(nLin,3)) 
   	      		    	    REPLACE CT2->CT2_MOEDLC  WITH "01"
   	      		    	    REPLACE CT2->CT2_DC      WITH "2" 
   	      		    	    REPLACE CT2->CT2_CREDIT  WITH cConta
   	      		    	    REPLACE CT2->CT2_VALOR   WITH nSaldo
   	      		    	    nSaldo := 0
   	      		    	    REPLACE CT2->CT2_HIST    WITH "CEC " +aTit2[n,1]+ " " +alltrim(aTit2[n,2])+ " " +alltrim(aTit2[n,7])
   	      		    	    REPLACE CT2->CT2_ITEMC   WITH aTit[i,1]
   	      		    	    REPLACE CT2->CT2_EMPORI  WITH "01"
		  		    	    REPLACE CT2->CT2_FILORI  WITH aTit[i,1]  
		  		    	    REPLACE CT2->CT2_TPSALD  WITH "9"
   	      		    	    REPLACE CT2->CT2_SEQUEN  WITH nSeqCt2
   	      		    	    REPLACE CT2->CT2_MANUAL  WITH "2"
   	      		    	    REPLACE CT2->CT2_ORIGEM  WITH "BRP294"
   	      		    	    REPLACE CT2->CT2_ROTINA  WITH "BRP294"
   	      		    	    REPLACE CT2->CT2_AGLUT   WITH "1"
   	      		    	    REPLACE CT2->CT2_LP      WITH "000"
   	      		    	    REPLACE CT2->CT2_SEQHIS  WITH "001"
   	      		    	    REPLACE CT2->CT2_SEQLAN  WITH ALLTRIM(STRZERO(nLin,3))
   	      		    	    nLin := nLin + 1 
   	      		    	    REPLACE CT2->CT2_CRCONV  WITH "1"
   	      		    	    REPLACE CT2->CT2_DTCV3   WITH DDATABASE
   	      		    	    
			        	 ENDIF   
			        	    CT2->(MSUNLOCK())  //FIM GERACAO DA CT2
   	      		 	endif
   	      		  
   	      		 	REPLACE SE5->E5_NATUREZ  WITH  aTit[i,12]
   	      		 	REPLACE SE5->E5_RECPAG   WITH  "R"
   	      		 	REPLACE SE5->E5_BENEF    WITH  aTit[i,7]
   	      		 	REPLACE SE5->E5_HISTOR   WITH  "Vlr Rbo por comp. NF " +aTit2[n,3]+ " " +alltrim(str(Val(aTit2[n,2])))
   	      		 	REPLACE SE5->E5_TIPODOC  WITH  "BA"
   	      		 	REPLACE SE5->E5_NUMERO   WITH  aTit[i,2]
   	      		 	REPLACE SE5->E5_PARCELA  WITH  aTit[i,3]
   	      		 	REPLACE SE5->E5_CLIFOR   WITH  aTit[i,5]
   	      		 	REPLACE SE5->E5_CLIENTE  WITH  aTit[i,5]
   	      		 	REPLACE SE5->E5_LOJA     WITH  aTit[i,6]
   	      		 	REPLACE SE5->E5_FILORIG  WITH  aTit[i,1]
   	      		 	REPLACE SE5->E5_DTDIGIT  WITH  DDATABASE
   	      			REPLACE SE5->E5_MOTBX    WITH  "CEC"
   	      		 	REPLACE SE5->E5_SEQ      WITH  "01"
   	      		 	REPLACE SE5->E5_DTDISPO  WITH  DDATABASE 
   	      		 	REPLACE SE5->E5_LA       WITH  "S"
   	      		                                                     
   	      		 	cQuery:="SELECT MAX(E5_IDENTEE)+1 AS PROX FROM "+RetSqlName("SE5")+" "
   	      		 	ChangeQuery(cQuery)                              
                 	DbUseArea(.T., "TOPCONN", TCGenQry(,,cQuery), 'PROX', .F., .T.)   
                 
                 	nNextEE := PROX->PROX
                 
                 
                 	REPLACE SE5->E5_IDENTEE  WITH  ALLTRIM(STRZERO(nNextEE,6))
                 
   	          	 ENDIF     //fim RECLOCK("SE5",.T.)
   	  	   
   	  	         SE5->(MSUNLOCK())
   	  	         PROX->(DBCLOSEAREA()) 
   	  	   	      
   	  	         IF RECLOCK("ZZC",.T.)
	      		     if nValZZC > 0
	      		   		REPLACE ZZC->ZZC_DATA    WITH  DDATABASE
	      		   		REPLACE ZZC->ZZC_DOC     WITH  cNUM
   	      		   		REPLACE ZZC->ZZC_SEQ     WITH  alltrim(strzero(nNumSeq,3))
		   	       		REPLACE ZZC->ZZC_PREFIX  WITH  aTit[i,1]
		   	      		REPLACE ZZC->ZZC_TIPO    WITH  "R"
   	      		  		REPLACE ZZC->ZZC_NUM     WITH  aTit[i,2]
   	      		   		REPLACE ZZC->ZZC_PARC    WITH  aTit[i,3]
   	      		   		REPLACE ZZC->ZZC_CLIFOR  WITH  aTit[i,5]
   	      		   		REPLACE ZZC->ZZC_LOJA    WITH  aTit[i,6]
   	      		   		REPLACE ZZC->ZZC_VENCRE  WITH  aTit[i,9]
   	      		   		REPLACE ZZC->ZZC_EMISSA  WITH  aTit[i,8]
   	      		   		REPLACE ZZC->ZZC_VALOR   WITH  round(nValZZC,2)
   	      		   		REPLACE ZZC->ZZC_NOME    WITH  aTit[i,7]
   	      		
   	      		   		nNumSeq := nNumSeq + 1 
   	      		   		nValZZC :=0
   	      			 endif
   	             ENDIF     
   	  	         ZZC->(MSUNLOCK())  
        
   	  	      endif //fim nSaldo2 > 0 .and. nSaldo > 0
   	  	      
   	  	      //GERACAO SE5 CONTAS A PAGAR
              
              
              nValZZC:=0
             
             if nSaldo4 > 0 .and.  nSaldo3 > 0
                IF RECLOCK("SE5",.T.)
	      		   REPLACE SE5->E5_PREFIXO  WITH  aTit2[n,1]
   	      		   REPLACE SE5->E5_DATA     WITH  DDATABASE
   	      		   REPLACE SE5->E5_TIPO     WITH  aTit2[n,4]
		   	       REPLACE SE5->E5_MOEDA    WITH  "01"
		   	       REPLACE SE5->E5_LA       WITH  "S"  
		   	       REPLACE SE5->E5_DOCZZC   WITH  cNUM
		   	       REPLACE SE5->E5_SEQZZC   WITH  alltrim(strzero(nNumSeq,3))
		   	     
		   	       if nSaldo3 > nSaldo4
		   	             
		   	             REPLACE SE5->E5_VALOR    WITH  nSaldo4
   	      		         REPLACE SE5->E5_VLMOED2  WITH  nSaldo4 
   	      		         nValZZC:=nSaldo4
   	      		         nSaldo3 := nSaldo3 - nSaldo4 
   	      		         
   	      		         //nVlrMail:=nSaldo4
   	      		         //U_EnviaMail() // enviar e-mail  	      		              
   	      		            	      		         
   	      		            	      		    
   	      		         //BAIXAR O TITULO DO CONTAS A PAGAR
   	      		         //cQuery:="UPDATE "+RetSqlName("SE2")+" SET E2_BAIXA='"+DTOS(DDATABASE)+"',E2_STATUS='B',E2_VALLIQ=E2_VALOR,E2_SALDO='0' "  
   	      		         cQuery:="BEGIN TRAN "
   	      		         cQuery+="UPDATE "+RetSqlName("SE2")+" SET E2_BAIXA='"+DTOS(DDATABASE)+"',E2_STATUS='B',E2_SALDO='0' "
   	      		         cQuery+="WHERE D_E_L_E_T_<>'*' AND E2_PREFIXO = '"+aTit2[n,1]+"' AND "
			             cQuery+="E2_NUM = '"+aTit2[n,2]+"' AND E2_FORNECE =  '"+aTit2[n,5]+"' AND E2_LOJA = '"+aTit2[n,6]+"' AND "
			             cQuery+="E2_PARCELA = '"+aTit2[n,3]+"' AND E2_TIPO = '"+aTit2[n,4]+"' AND E2_PORTADO IN ('END','ENE') "
			             cQuery+="COMMIT"
			             TCSQLExec(cQuery) 
			             
			             //GERACAO DO MOVIMENTO DEBITO NA CT2 (CONTABILIZAO)
			        	 
			        	 IF EMPTY(nDocCt2) //SE AINDA NAO PEGOU O NUMERO DO DOC DA CT2
			        	    cQuery:="SELECT TOP 1 (CT2_DOC) + 1 AS PROX FROM "+RetSqlName("CT2")+"  WHERE CT2_LOTE='008850' "
			        	    cQuery+="AND CT2_DATA='"+DTOS(DDATABASE)+"' "
			        	    cQuery+="GROUP BY CT2_DOC ORDER BY CT2_DOC DESC "
			        	    ChangeQuery(cQuery)
                            DbUseArea(.T., "TOPCONN", TCGenQry(,,cQuery), 'DOCCT2', .F., .T.)
                         
                            nDocCt2 := ALLTRIM(STRZERO(DOCCT2->PROX,6)) //numero documento
                            DOCCT2->(DBCLOSEAREA())
                             
                            if EMPTY (nDocCt2) .or. nDocCt2 == "000000"
                               nDocCt2 := "000001"
                            endif   
                            
                            cQuery:="SELECT TOP 1 (CT2_SEQUEN) + 1 AS PROX FROM "+RetSqlName("CT2")+"  WHERE CT2_LOTE='008850' "
			        	    cQuery+="GROUP BY CT2_SEQUEN ORDER BY CT2_SEQUEN DESC "
			        	    ChangeQuery(cQuery)
                            DbUseArea(.T., "TOPCONN", TCGenQry(,,cQuery), 'SEQCT2', .F., .T.)
                         
                            nSeqCt2 := ALLTRIM(STRZERO(SEQCT2->PROX,10)) //numero documento
                            SEQCT2->(DBCLOSEAREA())
                            
                         ENDIF
			        	 
			        	 cConta := ALLTRIM(POSICIONE("SA2",1,xFILIAL("SA1")+aTit2[n,5]+aTit2[n,6],"A2_CONTA"))   //conta contabil cadastro de fornecedor
			        	 
			        	 IF RECLOCK("CT2",.T.) 
			        	    REPLACE CT2->CT2_DATA    WITH DDATABASE
   	      		    	    REPLACE CT2->CT2_LOTE    WITH "008850" 
   	      		    	    REPLACE CT2->CT2_DOCZZC  WITH cNUM
   	      		    	    REPLACE CT2->CT2_SEQZZC  WITH alltrim(strzero(nNumSeq,3))
   	      		    	    REPLACE CT2->CT2_SBLOTE  WITH "001"
   	      		    	    REPLACE CT2->CT2_DOC     WITH nDocCt2
   	      		    	    REPLACE CT2->CT2_LINHA   WITH ALLTRIM(STRZERO(nLin,3)) 
   	      		    	    REPLACE CT2->CT2_MOEDLC  WITH "01"
   	      		    	    REPLACE CT2->CT2_DC      WITH "1" 
   	      		    	    REPLACE CT2->CT2_DEBITO  WITH cConta
   	      		    	    REPLACE CT2->CT2_VALOR   WITH nSaldo4
   	      		    	    nSaldo4 := 0
   	      		    	    REPLACE CT2->CT2_HIST    WITH "CEC " +aTit[i,1]+ " " +alltrim(aTit[i,2])+ " " +alltrim(aTit[i,7])
   	      		    	    REPLACE CT2->CT2_ITEMD   WITH aTit2[n,1]
   	      		    	    REPLACE CT2->CT2_EMPORI  WITH "01"
		  		    	    REPLACE CT2->CT2_FILORI  WITH aTit2[n,1]  
		  		    	    REPLACE CT2->CT2_TPSALD  WITH "9"
   	      		    	    REPLACE CT2->CT2_SEQUEN  WITH nSeqCt2
   	      		    	    REPLACE CT2->CT2_MANUAL  WITH "2"
   	      		    	    REPLACE CT2->CT2_ORIGEM  WITH "BRP294"
   	      		    	    REPLACE CT2->CT2_ROTINA  WITH "BRP294"
   	      		    	    REPLACE CT2->CT2_AGLUT   WITH "1"
   	      		    	    REPLACE CT2->CT2_LP      WITH "000"
   	      		    	    REPLACE CT2->CT2_SEQHIS  WITH "001"
   	      		    	    REPLACE CT2->CT2_SEQLAN  WITH ALLTRIM(STRZERO(nLin,3))
   	      		    	    nLin := nLin + 1 
   	      		    	    REPLACE CT2->CT2_CRCONV  WITH "1"
   	      		    	    REPLACE CT2->CT2_DTCV3   WITH DDATABASE
   	      		    	    
			        	 ENDIF   
			        	    CT2->(MSUNLOCK())  //FIM GERACAO DA CT2
   	      		 
   	      		   elseif nSaldo3 <= nSaldo4
   	      		    
   	      		         REPLACE SE5->E5_VALOR    WITH  nSaldo3 
		   	             REPLACE SE5->E5_VLMOED2  WITH  nSaldo3 
		   	             nValZZC:=nSaldo3 
   	      		    
   	      		         //nVlrMail:=nSaldo3
   	      		         //U_EnviaMail() // enviar e-mail  	      		              
   	      		           	      		         
   	      		         //BAIXAR TITULO NA SE2
   	      		         //cQuery:="UPDATE "+RetSqlName("SE2")+" SET E2_BAIXA='"+DTOS(DDATABASE)+"',E2_VALLIQ='"+ALLTRIM(STR(nSaldo3))+"', "
   	      		         cQuery:="BEGIN TRAN "
   	      		         cQuery+="UPDATE "+RetSqlName("SE2")+" SET E2_BAIXA='"+DTOS(DDATABASE)+"', "
   	      		         cQuery+="E2_SALDO = (E2_SALDO - "+ALLTRIM(STR(nSaldo3))+") "
   	      		         cQuery+="WHERE D_E_L_E_T_<>'*' AND E2_PREFIXO = '"+aTit2[n,1]+"' AND "
			             cQuery+="E2_NUM = '"+aTit2[n,2]+"' AND E2_FORNECE =  '"+aTit2[n,5]+"' AND E2_LOJA = '"+aTit2[n,6]+"' AND "
			             cQuery+="E2_PARCELA = '"+aTit2[n,3]+"' AND E2_TIPO = '"+aTit2[n,4]+"' AND E2_PORTADO IN ('END','ENE') "
			             cQuery+="COMMIT"
			             TCSQLExec(cQuery)
			        
			             nSaldo4 := nSaldo4 - nSaldo3 
   	      		            	      		         
   	      		         //GERACAO DO MOVIMENTO DEBITO NA CT2 (CONTABILIZAO)
			        	 
			        	 IF EMPTY(nDocCt2) //SE AINDA NAO PEGOU O NUMERO DO DOC DA CT2
			        	    cQuery:="SELECT TOP 1 (CT2_DOC) + 1 AS PROX FROM "+RetSqlName("CT2")+"  WHERE CT2_LOTE='008850' "
			        	    cQuery+="AND CT2_DATA='"+DTOS(DDATABASE)+"' "
			        	    cQuery+="GROUP BY CT2_DOC ORDER BY CT2_DOC DESC "
			        	    ChangeQuery(cQuery)
                            DbUseArea(.T., "TOPCONN", TCGenQry(,,cQuery), 'DOCCT2', .F., .T.)
                         
                            nDocCt2 := ALLTRIM(STRZERO(DOCCT2->PROX,6)) //numero documento
                            DOCCT2->(DBCLOSEAREA())
                            
                            if EMPTY (nDocCt2) .or. nDocCt2 == "000000"
                               nDocCt2 := "000001"
                            endif   
                            
                            cQuery:="SELECT TOP 1 (CT2_SEQUEN) + 1 AS PROX FROM "+RetSqlName("CT2")+"  WHERE CT2_LOTE='008850' "
			        	    cQuery+="GROUP BY CT2_SEQUEN ORDER BY CT2_SEQUEN DESC "
			        	    ChangeQuery(cQuery)
                            DbUseArea(.T., "TOPCONN", TCGenQry(,,cQuery), 'SEQCT2', .F., .T.)
                         
                            nSeqCt2 := ALLTRIM(STRZERO(SEQCT2->PROX,10)) //numero documento
                            SEQCT2->(DBCLOSEAREA())
                            
                         ENDIF
			        	 
			        	 cConta := ALLTRIM(POSICIONE("SA2",1,xFILIAL("SA1")+aTit2[n,5]+aTit2[n,6],"A2_CONTA"))   //conta contabil cadastro de fornecedor
			        	 
			        	 IF RECLOCK("CT2",.T.) 
			        	    REPLACE CT2->CT2_DATA    WITH DDATABASE
   	      		    	    REPLACE CT2->CT2_LOTE    WITH "008850" 
   	      		    	    REPLACE CT2->CT2_DOCZZC  WITH cNUM
   	      		    	    REPLACE CT2->CT2_SEQZZC  WITH alltrim(strzero(nNumSeq,3))
   	      		    	    REPLACE CT2->CT2_SBLOTE  WITH "001"
   	      		    	    REPLACE CT2->CT2_DOC     WITH nDocCt2
   	      		    	    REPLACE CT2->CT2_LINHA   WITH ALLTRIM(STRZERO(nLin,3)) 
   	      		    	    REPLACE CT2->CT2_MOEDLC  WITH "01"
   	      		    	    REPLACE CT2->CT2_DC      WITH "1" 
   	      		    	    REPLACE CT2->CT2_DEBITO  WITH cConta
   	      		    	    REPLACE CT2->CT2_VALOR   WITH nSaldo3
   	      		    	    nSaldo3 := nSaldo3 - nSaldo3
   	      		    	    REPLACE CT2->CT2_HIST    WITH "CEC " +aTit[i,1]+ " " +alltrim(aTit[i,2])+ " " +alltrim(aTit[i,7])
   	      		    	    REPLACE CT2->CT2_ITEMD   WITH aTit2[n,1]
   	      		    	    REPLACE CT2->CT2_EMPORI  WITH "01"
		  		    	    REPLACE CT2->CT2_FILORI  WITH aTit2[n,1]  
		  		    	    REPLACE CT2->CT2_TPSALD  WITH "9"
   	      		    	    REPLACE CT2->CT2_SEQUEN  WITH nSeqCt2
   	      		    	    REPLACE CT2->CT2_MANUAL  WITH "2"
   	      		    	    REPLACE CT2->CT2_ORIGEM  WITH "BRP294"
   	      		    	    REPLACE CT2->CT2_ROTINA  WITH "BRP294"
   	      		    	    REPLACE CT2->CT2_AGLUT   WITH "1"
   	      		    	    REPLACE CT2->CT2_LP      WITH "000"
   	      		    	    REPLACE CT2->CT2_SEQHIS  WITH "001"
   	      		    	    REPLACE CT2->CT2_SEQLAN  WITH ALLTRIM(STRZERO(nLin,3))
   	      		    	    nLin := nLin + 1 
   	      		    	    REPLACE CT2->CT2_CRCONV  WITH "1"
   	      		    	    REPLACE CT2->CT2_DTCV3   WITH DDATABASE
   	      		    	    
			        	 ENDIF   
			        	    CT2->(MSUNLOCK())  //FIM GERACAO DA CT2
   	      		       	      		    
   	      		   endif
   	      		  
   	      				 REPLACE SE5->E5_NATUREZ  WITH  aTit2[n,12]
   	      		 		 REPLACE SE5->E5_RECPAG   WITH  "P"
   	      		 		 REPLACE SE5->E5_BENEF    WITH  aTit2[n,7]
   	      		   		 REPLACE SE5->E5_HISTOR   WITH  "Vlr pg por comp. NF " +aTit[i,3]+ " " +alltrim(str(Val(aTit[i,2])))                                  
   	      		 		 REPLACE SE5->E5_TIPODOC  WITH  "BA"
   	      		 		 REPLACE SE5->E5_NUMERO   WITH  aTit2[n,2]
   	      		 		 REPLACE SE5->E5_PARCELA  WITH  aTit2[n,3]
   	      		 		 REPLACE SE5->E5_CLIFOR   WITH  aTit2[n,5]
   	      		 		 REPLACE SE5->E5_FORNECE  WITH  aTit2[n,5]
   	      		 		 REPLACE SE5->E5_LOJA     WITH  aTit2[n,6]
   	      		 		 REPLACE SE5->E5_FILORIG  WITH  aTit2[n,1]
   	      		 		 REPLACE SE5->E5_DTDIGIT  WITH  DDATABASE
   	      		 		 REPLACE SE5->E5_MOTBX    WITH  "CEC"
   	      		 		 REPLACE SE5->E5_SEQ      WITH  "01"
   	      		 		 REPLACE SE5->E5_DTDISPO  WITH  DDATABASE
   	      		 		 REPLACE SE5->E5_IDENTEE  WITH  ALLTRIM(STRZERO(nNextEE,6))
                ENDIF     
   	  	   
   	  	        SE5->(MSUNLOCK()) 
   	  	   
   	  	   
   	  	       IF RECLOCK("ZZC",.T.)
	      		if nValZZC > 0
	      		   REPLACE ZZC->ZZC_DATA    WITH  DDATABASE
	      		   REPLACE ZZC->ZZC_DOC     WITH  cNUM
   	      		   REPLACE ZZC->ZZC_SEQ     WITH  alltrim(strzero(nNumSeq,3))
		   	       REPLACE ZZC->ZZC_PREFIX  WITH  aTit2[n,1]
		   	       REPLACE ZZC->ZZC_TIPO    WITH  "P"
   	      		   REPLACE ZZC->ZZC_NUM     WITH  aTit2[n,2]
   	      		   REPLACE ZZC->ZZC_PARC    WITH  aTit2[n,3]
   	      		   REPLACE ZZC->ZZC_CLIFOR  WITH  aTit2[n,5]
   	      		   REPLACE ZZC->ZZC_LOJA    WITH  aTit2[n,6]
   	      		   REPLACE ZZC->ZZC_VENCRE  WITH  aTit2[n,9]
   	      		   REPLACE ZZC->ZZC_EMISSA  WITH  aTit2[n,8]
   	      		   REPLACE ZZC->ZZC_VALOR   WITH  round(nValZZC,2)
   	      		   REPLACE ZZC->ZZC_NOME    WITH  aTit2[n,7]
   	      		   REPLACE ZZC->ZZC_ORIGEM  WITH  aTit[i,1]+alltrim(aTit[i,2])
   	      		      		   
   	      		   nNumSeq := nNumSeq + 1
   	      		endif
   	           ENDIF  //fim RECLOCK("ZZC",.T.)  
   	  	       ZZC->(MSUNLOCK())  
   	  	     endif //fim nSaldo4 > 0 .and.  nSaldo3 > 0
              endif  //fim nSaldo2 > 0 .and. nSaldo > 0
       next
    next         

    IF nNumSeq > 1
       MsgAlert("Concluido. Para emitir a Carta use o numero do documento " +alltrim(cNUM))//,"Atencao","ALERT") 
       MsgAlert("Compensacoes efetuadas na base.")//,"Atencao","ALERT")  
    else
       MsgAlert("Nenhuma operacao efetuada. Verificar Parametros ou falar com a TI")//,"Atencao","ALERT") 
    endif

    IF nNumSeq > 1 .and. nLin > 1
       MsgAlert("Pre-Lancamentos Contabeis Gravados na CT2 Com Sucesso!!")//,"Atencao","ALERT") 
    endif

    IF MsgYesNo("Deseja Imprimir as Cartas de Endosso neste exato momento ? " )  
       U_Brp295()
    endif   

endif // fim do yes/no
    
return

Static Function C(nTam)
Local nHRes	:=	oMainWnd:nClientWidth	// Resolucao horizontal do monitor
If nHRes == 640	// Resolucao 640x480 (soh o Ocean e o Classic aceitam 640)
	nTam *= 0.8
ElseIf (nHRes == 798).Or.(nHRes == 800)	// Resolucao 800x600
	nTam *= 1
Else	// Resolucao 1024x768 e acima
	nTam *= 1.28
EndIf

//Ŀ
//Tratamento para tema "Flat"
//
If "MP8" $ oApp:cVersion
	If (Alltrim(GetTheme()) == "FLAT") .Or. SetMdiChild()
		nTam *= 0.90
	EndIf
EndIf
Return Int(nTam)


******************************************
Static Function MarcarTudo()
DbSelectArea('TC9')
dbGoTop()
cVlrRec:=0
While !Eof()
	MsProcTxt('Aguarde...')
	RecLock('TC9',.F.)
	TC9->T9_OK := _cMarca
	cVlrRec := cVlrRec + tc9->t9_saldo
	MsUnlock()
	DbSkip()
EndDo
DbGoTop()
DlgRefresh(oDlgTitulos)
SysRefresh()

DbSelectArea('TC8')
dbGoTop()
cVlrPag:=0
While !Eof()
	MsProcTxt('Aguarde...')
	RecLock('TC8',.F.)
	TC8->T8_OK := _cMarca
	cVlrPag:=cVlrPag+tc8->t8_saldo
	MsUnlock()
	DbSkip()
EndDo
DbGoTop()
DlgRefresh(oDlgTitulos)
SysRefresh()

Return(.T.)

******************************************
Static Function DesmarcaTudo()
DbSelectArea('TC9')
dbGoTop()
cVlrRec:=0
While !Eof()
	MsProcTxt('Aguarde...')
	RecLock('TC9',.F.)
	TC9->T9_OK := ThisMark()
	MsUnlock()
	DbSkip()
EndDo
DbGoTop()
DlgRefresh(oDlgTitulos)
SysRefresh()

DbSelectArea('TC8')
dbGoTop()
cVlrPag:=0
While !Eof()
	MsProcTxt('Aguarde...')
	RecLock('TC8',.F.)
	TC8->T8_OK := ThisMark()
	MsUnlock()
	DbSkip()
EndDo
DbGoTop()
DlgRefresh(oDlgTitulos)
SysRefresh()

Return(.T.)


******************************************
Static Function Marcar()
DbSelectArea('TC9')
RecLock('TC9',.F.)
If Empty(TC9->T9_OK)
	cVlrRec := cVlrRec + tc9->t9_saldo
	TC9->T9_OK := _cMarca
else
    cVlrRec := cVlrRec  - tc9->t9_saldo
Endif
MsUnlock()
SysRefresh() 
Return(.T.)

Static Function MarcarTC8()
DbSelectArea('TC8')
RecLock('TC8',.F.)
If Empty(TC8->T8_OK)
	cVlrPag := cVlrPag + tc8->t8_saldo
	TC8->T8_OK := _cMarca  
else
	cVlrPag := cVlrPag - tc8->t8_saldo
Endif
MsUnlock()
SysRefresh()
Return(.T.)

******************************************************
Static FUNCTION Cria_TC9()

If Select("TC9") <> 0
	TC9->(dbCloseArea())
Endif  

If Select("TC8") <> 0
	TC8->(dbCloseArea())
Endif

aFields   := {}
AADD(aFields,{"T9_OK"     ,"C",02,0})
AADD(aFields,{"T9_NATUREZ"     ,"C",10,0})
AADD(aFields,{"T9_PREFIXO"     ,"C",02,0})
AADD(aFields,{"T9_NUM" ,"C",09,0})
AADD(aFields,{"T9_PARCELA"   ,"C",03,0})
AADD(aFields,{"T9_VALOR"  ,"N",15,6})
AADD(aFields,{"T9_SALDO"  ,"N",15,6})
AADD(aFields,{"T9_TIPO","C",3,0})
AADD(aFields,{"T9_CLIENTE"   ,"C",6,0})
AADD(aFields,{"T9_LOJA"     ,"C",02,0})
AADD(aFields,{"T9_NOMCLI"   ,"C",25,6})
AADD(aFields,{"T9_EMISSAO"   ,"D",08,6})
AADD(aFields,{"T9_VENCREA"  ,"D",08,2})
cArq:=Criatrab(aFields,.T.)
DBUSEAREA(.t.,,cArq,"TC9")

aFields2   := {}
AADD(aFields2,{"T8_OK"     ,"C",02,0})
AADD(aFields2,{"T8_NATUREZ"     ,"C",10,0})
AADD(aFields2,{"T8_PREFIXO"     ,"C",02,0})
AADD(aFields2,{"T8_NUM" ,"C",09,0})
AADD(aFields2,{"T8_PARCELA"   ,"C",03,0})
AADD(aFields2,{"T8_VALOR"  ,"N",15,6})
AADD(aFields2,{"T8_SALDO"  ,"N",15,6})
AADD(aFields2,{"T8_TIPO","C",3,0})
AADD(aFields2,{"T8_FORNECE"   ,"C",6,0})
AADD(aFields2,{"T8_LOJA"     ,"C",02,0})
AADD(aFields2,{"T8_NOMFOR"   ,"C",25,6})
AADD(aFields2,{"T8_EMISSAO"   ,"D",08,6})
AADD(aFields2,{"T8_VENCREA"  ,"D",08,2})
cArq2:=Criatrab(aFields2,.T.)
DBUSEAREA(.t.,,cArq2,"TC8")
Return


********************************************
Static Function Monta_TC9()

cQuery:="SELECT E1_PREFIXO T9_PREFIXO,E1_NUM T9_NUM, E1_PARCELA T9_PARCELA,E1_TIPO T9_TIPO, E1_CLIENTE T9_CLIENTE,E1_LOJA T9_LOJA, "
cQuery+="SUBSTRING(E1_NOMCLI,1,25) T9_NOMCLI, E1_EMISSAO T9_EMISSAO, E1_VENCREA T9_VENCREA, E1_VALOR T9_VALOR,E1_SALDO T9_SALDO, "
cQuery+="E1_NATUREZ T9_NATUREZ "
cQuery+="FROM "+RetSqlName("SE1")+" WHERE D_E_L_E_T_<>'*' AND E1_PREFIXO BETWEEN '"+mv_par01+"' AND '"+mv_par02+"' AND "
cQuery+="E1_CLIENTE = '"+mv_par04+"' AND E1_SALDO > '0' AND E1_VENCREA BETWEEN '"+dtos(mv_par05)+"' AND '"+dtos(mv_par06)+"' "

if mv_par13 = 2  //considera bordero? = nao
   cQuery+="AND E1_PORTADO IN ('','END','ENE') AND E1_TIPO = 'NF' AND E1_NUM BETWEEN '"+mv_par09+"' AND '"+mv_par10+"' " 
   cQuery+="AND E1_NUMBOR='' " 
elseif mv_par13 = 1  //considerar bordero =sim
   cQuery+="AND E1_TIPO = 'NF' AND E1_NUM BETWEEN '"+mv_par09+"' AND '"+mv_par10+"' " 
endif

if sm0->m0_codfil == "07"    //FILIAL SUL SO PESQUISA TITULOS DO SUL
   cQuery+="AND E1_PREFIXO = '07' "
ENDIF
cQuery+="ORDER BY E1_NUM,E1_NOMCLI"
cQuery:= ChangeQuery(cQuery)
dbUseArea(.T.,"TOPCONN",TcGenQry(,,cQuery),"CAD",.T.,.T.)
TcSetField("CAD","T9_EMISSAO","D",8,0)  
TcSetField("CAD","T9_VENCREA","D",8,0)  

Dbselectarea("CAD")

While CAD->(!EOF())
	RecLock("TC9",.T.)
	For _nX := 1 To Len(aFields)
		If !(aFields[_nX,1] $ 'T9_OK')
		  _cX := 'TC9->'+aFields[_nX,1]+' := (CAD->'+aFields[_nX,1]+')'
		  _cX := &_cX 
		  
		Endif
	Next
	TC9->T9_OK := _cMarca 
	MsUnLock()
	
    cVlrRec:=cVlrRec+cad->T9_SALDO
		
	DbSelectArea('CAD')
	CAD->(dBSkip())
EndDo

Dbselectarea("CAD")
DbCloseArea()
Dbselectarea("TC9")
DbGoTop()

_cIndex:=Criatrab(Nil,.F.)
_cChave:="T9_NUM"
Indregua("TC9",_cIndex,_cChave,,,"Ordenando registros selecionados...")
DbSetIndex(_cIndex+ordbagext())
SysRefresh()
Return


Static Function Monta_TC8()

cQuery:="SELECT E2_PREFIXO T8_PREFIXO,E2_NUM T8_NUM, E2_PARCELA T8_PARCELA,E2_TIPO T8_TIPO, E2_FORNECE T8_FORNECE,E2_LOJA T8_LOJA, "
cQuery+="SUBSTRING(E2_NOMFOR,1,25) T8_NOMFOR, E2_EMISSAO T8_EMISSAO, E2_VENCREA T8_VENCREA, E2_VALOR T8_VALOR,E2_SALDO T8_SALDO, " 
cQuery+="E2_NATUREZ T8_NATUREZ "
cQuery+="FROM "+RetSqlName("SE2")+" WHERE D_E_L_E_T_<>'*' AND E2_PREFIXO BETWEEN '"+mv_par01+"' AND '"+mv_par02+"' AND "
cQuery+="E2_FORNECE = '"+mv_par03+"' AND E2_SALDO > '0' AND E2_VENCREA BETWEEN '"+dtos(mv_par07)+"' AND '"+dtos(mv_par08)+"' "
cQuery+="AND E2_TIPO IN ('NF','JP') AND E2_NUM BETWEEN '"+mv_par11+"' AND '"+mv_par12+"' AND E2_PORTADO IN ('','END','ENE') " 
cQuery+="AND E2_NUMBOR ='' " 

if sm0->m0_codfil == "07"    //FILIAL SUL SO PESQUISA TITULOS DO SUL
   cQuery+="AND E2_PREFIXO = '07' "
ENDIF
cQuery+="ORDER BY E2_NUM,E2_NOMFOR"
cQuery:= ChangeQuery(cQuery)
dbUseArea(.T.,"TOPCONN",TcGenQry(,,cQuery),"CAD2",.T.,.T.)
TcSetField("CAD2","T8_EMISSAO","D",8,0)  
TcSetField("CAD2","T8_VENCREA","D",8,0)  

Dbselectarea("CAD2")

While CAD2->(!EOF())
	RecLock("TC8",.T.)
	For _nX := 1 To Len(aFields2)
		If !(aFields2[_nX,1] $ 'T8_OK')
		  _cX := 'TC8->'+aFields2[_nX,1]+' := (CAD2->'+aFields2[_nX,1]+')'
		  _cX := &_cX
		Endif
	Next
	TC8->T8_OK := _cMarca 
	MsUnLock()
	
	cVlrPag:=cVlrPag+cad2->T8_SALDO
	
	DbSelectArea('CAD2')
	CAD2->(dBSkip())
EndDo

Dbselectarea("CAD2")
DbCloseArea()
Dbselectarea("TC8")
DbGoTop()

_cIndex:=Criatrab(Nil,.F.)
_cChave:="T8_NUM"
Indregua("TC8",_cIndex,_cChave,,,"Ordenando registros selecionados...")
DbSetIndex(_cIndex+ordbagext())
SysRefresh()
Return


StatiC Function Fecha()
Close(_oPT00005)
Return  

STATIC FUNCTION ValidPerg()
    *
	//-->> Compatibiliza o SX1 com novas perguntas
	cAlias := Alias()
	dbSelectArea("SX1")                                  
	dbSetOrder(1)         
    cPerg  := PADR(cPerg,10)           
	aRegs  := {}
    //-->> Novo grupo de perguntas
	aAdd(aRegs,{cPerg,"01","Do Prefixo           ?","","","mv_ch1","C", 2,0,0,"G","","Mv_Par01","","","","","","","","","","","","","","","","","","","","","","","","","",""})
	aAdd(aRegs,{cPerg,"02","Ate Prefixo          ?","","","mv_ch2","C", 2,0,0,"G","","Mv_Par02","","","","","","","","","","","","","","","","","","","","","","","","","",""})   
	aAdd(aRegs,{cPerg,"03","Fornecedor           ?","","","mv_ch3","C", 6,0,0,"G","","Mv_Par03","","","","","","","","","","","","","","","","","","","","","","","","","SA2",""})
	aAdd(aRegs,{cPerg,"04","Cliente              ?","","","mv_ch4","C", 6,0,0,"G","","Mv_Par04","","","","","","","","","","","","","","","","","","","","","","","","","SA1",""})   
	aAdd(aRegs,{cPerg,"05","Vencto CR de         ?","","","mv_ch5","D", 8,0,0,"G","","Mv_Par05","","","","","","","","","","","","","","","","","","","","","","","","","",""})
	aAdd(aRegs,{cPerg,"06","Vencto CR Ate        ?","","","mv_ch6","D", 8,0,0,"G","","Mv_Par06","","","","","","","","","","","","","","","","","","","","","","","","","",""})
	aAdd(aRegs,{cPerg,"07","Vencto CP de         ?","","","mv_ch7","D", 8,0,0,"G","","Mv_Par07","","","","","","","","","","","","","","","","","","","","","","","","","",""})
	aAdd(aRegs,{cPerg,"08","Vencto CP Ate        ?","","","mv_ch8","D", 8,0,0,"G","","Mv_Par08","","","","","","","","","","","","","","","","","","","","","","","","","",""})
	aAdd(aRegs,{cPerg,"09","Titulo CR de         ?","","","mv_ch9","C", 9,0,0,"G","","Mv_Par09","","","","","","","","","","","","","","","","","","","","","","","","","",""})
	aAdd(aRegs,{cPerg,"10","Titulo CR Ate        ?","","","mv_chA","C", 9,0,0,"G","","Mv_Par10","","","","","","","","","","","","","","","","","","","","","","","","","",""})   
	aAdd(aRegs,{cPerg,"11","Titulo CP de         ?","","","mv_chB","C", 9,0,0,"G","","Mv_Par11","","","","","","","","","","","","","","","","","","","","","","","","","",""})
	aAdd(aRegs,{cPerg,"12","Titulo CP Ate        ?","","","mv_chC","C", 9,0,0,"G","","Mv_Par12","","","","","","","","","","","","","","","","","","","","","","","","","",""})   
    AAdd(aRegs,{cPerg,"13","Considera Bordero?","Considera Bordero?","Considera Bordero?","MV_CHD","C",1,0,1, "C","","MV_PAR13","Sim","","","","","Nao","","","","","","","","","","","","","","","","",""})

    *
	FOR i:=1 to Len(aRegs)
    IF !dbSeek(cPerg+aRegs[i,2])
        RecLock("SX1",.T.)
        FOR j:=1 to FCount()
            IF j <= Len(aRegs[i])
               FieldPut(j,aRegs[i,j])
            ENDIF
        NEXT
        MsUnlock()
    ENDIF
	NEXT
    *
	DBSELECTAREA( cAlias)
RETURN 